__gnu_pbds::detail::pat_trie_base::_CIter< Node, Leaf, Head, Inode, Is_Forward_Iterator >(3)

NAME
__gnu_pbds::detail::pat_trie_base::_CIter< Node, Leaf, Head, Inode, Is_Forward_Iterator > - Const iterator.

SYNOPSIS

Inherited by __gnu_pbds::detail::pat_trie_base::_Iter< Node, Leaf, Head, Inode, Is_Forward_Iterator >.

  Public Types
typedef allocator_type _Alloc
typedef Node::allocator_type allocator_type
typedef type_traits::const_pointer const_pointer
typedef type_traits::const_reference const_reference
typedef allocator_type::difference_type difference_type
typedef rebind_traits< _Alloc, Head >::pointer head_pointer
typedef Inode::iterator inode_iterator
typedef rebind_traits< _Alloc, Inode >::pointer inode_pointer
typedef std::bidirectional_iterator_tag iterator_category
typedef rebind_traits< _Alloc, Leaf >::const_pointer leaf_const_pointer
typedef rebind_traits< _Alloc, Leaf >::pointer leaf_pointer
typedef rebind_traits< _Alloc, Node >::pointer node_pointer
typedef type_traits::pointer pointer
typedef type_traits::reference reference
typedef Node::type_traits type_traits
typedef type_traits::value_type value_type

  Public Member Functions
_CIter (const _CIter< Node, Leaf, Head, Inode, !Is_Forward_Iterator > &other)
_CIter (node_pointer p_nd=0)
bool operator!= (const _CIter &other) const
bool operator!= (const _CIter< Node, Leaf, Head, Inode, !Is_Forward_Iterator > &other) const
const_reference operator* () const
_CIter & operator++ ()
_CIter operator++ (int)
_CIter & operator-- ()
_CIter operator-- (int)
const_pointer operator-> () const
_CIter & operator= (const _CIter &other)
_CIter & operator= (const _CIter< Node, Leaf, Head, Inode, !Is_Forward_Iterator > &other)
bool operator== (const _CIter &other) const
bool operator== (const _CIter< Node, Leaf, Head, Inode, !Is_Forward_Iterator > &other) const

  Public Attributes
node_pointer m_p_nd

  Protected Member Functions
void dec (false_type)
void dec (true_type)
void inc (false_type)
void inc (true_type)

  Static Protected Member Functions
static node_pointer get_larger_sibling (node_pointer p_nd)
static node_pointer get_smaller_sibling (node_pointer p_nd)
static leaf_pointer leftmost_descendant (node_pointer p_nd)
static leaf_pointer rightmost_descendant (node_pointer p_nd)

Detailed Description

  template<typename Node, typename Leaf, typename Head, typename Inode, bool Is_Forward_Iterator>
class __gnu_pbds::detail::pat_trie_base::_CIter< Node, Leaf, Head, Inode, Is_Forward_Iterator >" Const iterator.

Definition at line 487 of file pat_trie_base.hpp.

Author

Generated automatically by Doxygen for libstdc++ from the source code.